unit CMain;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
{$IFDEF Android}
  Androidapi.JNI.Net, Androidapi.Helpers,Androidapi.JNI.GraphicsContentViewText,
{$ELSE}
  FMX.Platform.iOS,
  FMX.Helpers.iOS,
  Macapi.Helpers,
{$ENDIF}
  FMX.Platform,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  FMX.Controls.Presentation, FMX.StdCtrls;

type
  TFormMain = class(TForm)
    tmrUpdate: TTimer;
    Button1: TButton;
    procedure tmrUpdateTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function HandleAppEvent(AAppEvent: TApplicationEvent; AContext: TObject): Boolean;
  end;

var
  FormMain: TFormMain;

implementation

{$R *.fmx}

procedure TFormMain.FormCreate(Sender: TObject);
var
  aFMXApplicationEventService: IFMXApplicationEventService;
begin
  if TPlatformServices.Current.SupportsPlatformService(IFMXApplicationEventService, IInterface(aFMXApplicationEventService)) then
    aFMXApplicationEventService.SetApplicationEventHandler(HandleAppEvent);
end;

function TFormMain.HandleAppEvent(AAppEvent: TApplicationEvent;
  AContext: TObject): Boolean;
{$IFDEF IOS}
var
  urlContext:TiOSOpenApplicationContext;
begin
  case AAppEvent of
    TApplicationEvent.OpenURL:
      begin
        urlContext:=TiOSOpenApplicationContext(AContext);
        TThread.Queue(nil, procedure
        begin
          ShowMessage(urlContext.URL);
        end);
      end;
  end;
  Result := True;
end;
{$ELSE}
begin

end;
{$ENDIF}

procedure TFormMain.tmrUpdateTimer(Sender: TObject);
{$IFDEF Android}
var
  data:JIntent;
  uri:JNet_uri;
begin
  //
  data:=SharedActivity.getIntent;
  if assigned(data) and Assigned(data.getAction()) and
    data.getAction.equals(TJIntent.JavaClass.ACTION_VIEW) then
  begin
    //
    uri:=data.getData;
    if Assigned(uri) then
    begin
//      TThread.Queue(nil, procedure
//      begin
        ShowMessage(JStringToString(uri.getPath));
        data.setData(nil);
//      end);
   end;
  end;
end;
{$ELSE}
begin
//

end;
{$ENDIF}

end.
